load_object "Cycles" ;;
#open "Cycles" ;;

type point == int * int ;;
type point_ou_bord = Point of point | Bord ;;

let rec dcoupe_en_deux = function
	  [] -> [],[]
	| [a] -> [a],[]
	| a :: b :: q ->	let l1,l2 = dcoupe_en_deux q
						in (a :: l1),(b :: l2)
and fusionne inf l1 l2 = match l1,l2 with
	  [],_ -> l2
	| _,[] -> l1
	| a :: q1 , b :: q2 ->	if (inf a b) then a :: (fusionne inf q1 l2)
							else b :: (fusionne inf l1 q2)
and tri_fusion inf = function
	  [] -> []
	| [a] -> [a]
	| l ->	let l1,l2 = dcoupe_en_deux l
			in fusionne inf (tri_fusion inf l1) (tri_fusion inf l2) ;;
			
let carr n = n * n ;;

let distance (x,y) (x',y') = carr(x-x') + carr(y-y') ;;

let numrote l =
	let rec numrote_rec n = function
		  [] -> []
		| a :: q -> (n,a) :: (numrote_rec (n+1) q)
	in
	numrote_rec 0 l ;;

let rec filtre prdicat = function
	  [] -> []
	| a :: q -> if (prdicat a) then a :: (filtre prdicat q)
				else (filtre prdicat q) ;;
				
let est_vide = function [] -> true | _ -> false ;;
										
let coupe_au_milieu l =
	let rec avance l1 a1 = function
		  [] -> a1,l1
		| l2 -> let a,l =
					if est_vide (tl l2)
						then avance (tl l1) a1 []
						else avance (tl l1) a1 (tl (tl l2))
				in ((hd l1) :: a),l
	in avance l [] l ;;
	
exception Trop_haut of
		(point*point*int*
		 point_ou_bord cycle_bien_chan*point_ou_bord cycle_bien_chan) ;;
		 
let rec cherche_mieux a b delta p1 p2 =
	let essai (a,b,delta,p1,p2) =
		match (valeur_cycle p1),(valeur_cycle p2) with
			  Bord,_ -> raise (Trop_haut (a,b,delta,p1,p2))
			| _,Bord -> raise (Trop_haut (a,b,delta,p1,p2))
			| Point(x1,y1),Point(x2,y2)
				->	if (y2 > y1) & (carr(y2-y1) >= delta) then
						raise (Trop_haut (a,b,delta,p1,p2))
					else	let d = distance (x1,y1) (x2,y2)
							in
							if d < delta then (x1,y1),(x2,y2),d,p1,(avance_cycle p2)
							else a,b,delta,p1,(avance_cycle p2)
	in
	match (valeur_cycle p1),(valeur_cycle p2) with
		  Bord,_ -> [a;b]
		| _,Bord -> [a;b]
		| Point(x1,y1),Point(x2,y2)
			->	if (y2 < y1) & (carr(y1-y2) >= delta) then
					cherche_mieux a b delta p1 (avance_cycle p2)
				else
					try let a,b,delta,_,_  = 
								essai(essai(essai(essai(essai(a,b,delta,p1,p2)))))
						in
						cherche_mieux a b delta (avance_cycle p1) p2
					with Trop_haut(a,b,delta,_,_)
							-> cherche_mieux a b delta (avance_cycle p1) p2 ;;
			
let paire_la_plus_proche l =
	let rec paire_la_plus_proche_rec lx ly = match lx with
	  [] -> []
	| [_,a] -> [a]
	| [_,a;_,b] -> [a;b]
	| [_,a;_,b;_,c]
		->	if (distance a b) < (distance a c)
			then	if (distance a b) < (distance b c)
					then [a;b]
					else [b;c]
			else	if (distance a c) < (distance b c)
					then [a;c]
					else [b;c]
	| _ ->
		let l1x,l2x = coupe_au_milieu lx
		in
		let indexMilieu = match (hd l2x) with i,(_,_) -> i
		in
		let l1y = filtre (function (i,_) -> i < indexMilieu) ly
		and l2y = filtre (function (i,_) -> i >= indexMilieu) ly
		in
		let [a1;b1] = paire_la_plus_proche_rec l1x l1y
		and [a2;b2] = paire_la_plus_proche_rec l2x l2y
		in
		let delta1,delta2 = (distance a1 b1),(distance a2 b2)
		in
		let m = match (hd l2x) with _,(x,_) -> x
		and aMin,bMin,delta = if delta1<delta2	then a1,b1,delta1
												else a2,b2,delta2
		in
		let p1 = filtre (function (_,(x,_)) -> carr(x-m) <= delta) l1y
		and p2 = filtre (function (_,(x,_)) -> carr(x-m) <= delta) l2y
		in
		let p1 = avance_cycle (liste_en_cycle 
								(Bord :: (map	(function (_,a) -> Point(a))
												p1)))
		and p2 = avance_cycle (liste_en_cycle 
								(Bord :: (map	(function (_,a) -> Point(a))
												p2)))
		in
		cherche_mieux aMin bMin delta p1 p2
	in
	let lx = numrote
				(tri_fusion (fun (ax,_) (bx,_) -> ax < bx)
							l)
	in
	let ly = tri_fusion (fun (_,(_,ay)) (_,(_,by)) -> ay < by)
						lx
	in
	paire_la_plus_proche_rec lx ly ;;
