let epsilon = 1.0e-8 ;;

let carr x = x *. x ;;

let d2 (ax,ay) (bx,by) = carr(ax -. bx) +. carr(ay -. by) ;;

let cercle_circonscrit (ax,ay) (bx,by) (cx,cy) =
	let a = d2 (ax,ay) (0.,0.)
	and b = d2 (bx,by) (0.,0.)
	and c = d2 (cx,cy) (0.,0.)
	and q = 2. *. (ax *. (by-.cy) +. bx *. (cy-.ay) +. cx *. (ay-.by))
	in
	(	(* abscisse du centre *)
		(a *. (by-.cy) +. b *. (cy-.ay) +. c *. (ay-.by))/.q
	,	(* ordonne du centre *)
		-.(a *. (bx-.cx) +. b *. (cx-.ax) +. c *. (ax-.bx))/.q
	)
	,	(* rayon du cercle *)
	sqrt((d2 (ax,ay) (bx,by))*.(d2 (bx,by) (cx,cy))*.(d2 (cx,cy) (ax,ay)))
	/. abs_float(q) ;;

let dterminant (ax,ay) (bx,by) = ax*.by -. ay*.bx ;;

let vecteur (ax,ay) (bx,by) = (bx-.ax,by-.ay) ;;

let sens_direct a b c = 0. <. (dterminant (vecteur a b) (vecteur a c)) ;;

let aligns a b c = abs_float(dterminant (vecteur a b) (vecteur a c)) <. epsilon ;;

let est_triangle a b c = not (aligns a b c) ;;
